%%
%% %CopyrightBegin%
%%
%% Copyright Ericsson AB 2010-2011. All Rights Reserved.
%%
%% The contents of this file are subject to the Erlang Public License,
%% Version 1.1, (the "License"); you may not use this file except in
%% compliance with the License. You should have received a copy of the
%% Erlang Public License along with this software. If not, it can be
%% retrieved online at http://www.erlang.org/.
%%
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%%
%% %CopyrightEnd%
%%

-module(ct_update_config_SUITE).

-suite_defaults([{timetrap, {minutes, 10}}]).

%% Note: This directive should only be used in test suites.
-compile(export_all).

-include("ct.hrl").

%% Test server callback functions
init_per_suite(Config) ->
    [{init_per_suite,now()}|Config].

end_per_suite(_Config) ->
    ok.

init_per_testcase(_TestCase, Config) ->
    [{init_per_testcase,now()}|Config].

end_per_testcase(_TestCase, _Config) ->
    ok.

init_per_group(GroupName, Config) ->
    [{init_per_group,now()}|Config].

end_per_group(GroupName, Config) ->
    ok.

all() ->
    [{group,group1}].

groups() ->
    [{group1,[],[test_case]}].
    
%% Test cases starts here.
test_case(Config) when is_list(Config) ->
    ok.
